
#ifndef __STDIO_REDIRECT_H__
#define __STDIO_REDIRECT_H__

// Dll or not
#ifndef STDREDIR_API
 	#define STDREDIR_API
 	#ifdef _DEBUG
		#pragma comment(lib, "STDRedirStaticD.lib")
	#else
		#pragma comment(lib, "STDRedirStatic.lib")
	#endif
#else
	#ifdef _DEBUG
		#pragma comment(lib, "STDRedirDll.lib")
	#else
		#pragma comment(lib, "STDRedirDll.lib")
	#endif
#endif

////////////////////////////////////

enum OutTypes
{
	OUT_STDOUT     = 0x0001, // stdout <stdio.h>
	OUT_STDERR     = 0x0002, // stderr <stdio.h>
	OUT_STDIO      = OUT_STDOUT | OUT_STDERR,

	OUT_COUT       = 0x0004, // cout   <iostream.h>
	OUT_CERR       = 0x0008, // cerr   <iostream.h>
	OUT_CLOG       = 0x0010, // clog   <iostream.h>
	OUT_IOSTREAM   = OUT_COUT | OUT_CERR | OUT_CLOG,

	OUT_OUTPUT_HANDLE = 0x0020, // STD_OUTPUT_HANDLE <winbase.h>
	OUT_ERROR_HANDLE  = 0x0040, // STD_ERROR_HANDLE  <winbase.h>
	OUT_STD_HANDLE    = OUT_OUTPUT_HANDLE | OUT_ERROR_HANDLE,

	OUT_ALL_STDOUT = OUT_STDOUT | OUT_COUT | OUT_OUTPUT_HANDLE,
	OUT_ALL_ERROR  = OUT_STDERR | OUT_CERR | OUT_ERROR_HANDLE,
	OUT_ALL        = OUT_STDIO | OUT_IOSTREAM | OUT_STD_HANDLE,
};

enum RedirectTypes
{
	REDIR_TO_NUL     , // redirect to null
	REDIR_TO_CON     , // redirect back to CON
	REDIR_TO_PRN     , // redirect to printer
	REDIR_TO_FILE    , // redirect to a file
	REDIR_TO_CALLBACK, // redirect to a callback function
};

// Callback function define
typedef VOID (*LPREDIRECT_CALLBACK)(LPCSTR szData, INT nDataSize, DWORD dwData);

////////////////////////////////////

BOOL STDREDIR_API RedirectStdout(INT outType, RedirectTypes redirectType, LPCSTR lpszFileName = NULL, BOOL bAppend = FALSE);
BOOL STDREDIR_API RedirectStdout(INT outType, RedirectTypes redirectType, LPREDIRECT_CALLBACK lpfnCallback, DWORD dwData = 0);

////////////////////////////////////

#endif//__STDIO_REDIRECT_H__
